package pwc.taxtech.atms.calendar;

import com.alibaba.druid.support.json.JSONUtils;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * <p> @Description </p>
 *
 * @Author: Mccoy Z Xia (Xia zhixin)
 * @Date: 2019-07-04 13:20
 * @Version: 1.0
 **/
@RestController
@RequestMapping("api/v1/")
public class CalendarController {

    @RequestMapping("taxCalendar/getAllTaxProjectList")
    @ResponseBody
    public Object getAllTaxProjectList(){
        Object result = JSONUtils.parse("[{\"id\":\"3D0B4C48-F79B-463F-B675-4413B7740420\",\"taxProjectName\":\"自定义事项\",\"orderIndex\":0,\"createTime\":\"2018-07-18T21:55:35+08:00\",\"updateTime\":\"2018-07-18T21:55:40+08:00\"},{\"id\":\"46C3A2D7-FC0D-4C85-819F-BF5528F7E77D\",\"taxProjectName\":\"企业所得税\",\"orderIndex\":2,\"createTime\":\"2018-07-05T09:05:56.597+08:00\",\"updateTime\":\"2018-07-05T09:05:56.597+08:00\"},{\"id\":\"0E53F69F-4C59-4257-BFBB-90337F0C1B8C\",\"taxProjectName\":\"个税\",\"orderIndex\":3,\"createTime\":\"2018-07-05T09:06:21.853+08:00\",\"updateTime\":\"2018-07-13T17:08:19.517+08:00\"},{\"id\":\"BD35F3E5-09AA-4075-9BCF-F42DD7E3BDBD\",\"taxProjectName\":\"印花税\",\"orderIndex\":4,\"createTime\":\"2018-07-05T09:07:26.197+08:00\",\"updateTime\":\"2018-08-29T18:41:40.347+08:00\"}]");
        return result;
    }

    @RequestMapping("taxCalendar/getWorkPlaceList")
    @ResponseBody
    public Object getWorkPlaceList(){
        Object result = JSONUtils.parse("[{\"id\":\"efc60e20-0c48-4ee0-82b7-6bdce2b8d8d7\",\"name\":\"阿里巴巴总部\",\"createTime\":\"2018-07-06T16:13:08.913+08:00\",\"updateTime\":\"2018-07-06T16:13:08.913+08:00\"},{\"id\":\"6437ece3-6bf0-4b96-88d0-aabcb6bca649\",\"name\":\"北京朝阳区税局\",\"createTime\":\"2018-07-11T13:39:32.47+08:00\",\"updateTime\":\"2018-07-18T11:22:42.227+08:00\"},{\"id\":\"3d258b22-438a-4d0a-a00f-dd78cbebd730\",\"name\":\"北京国贸\",\"createTime\":\"2019-03-07T11:39:08.04+08:00\",\"updateTime\":\"2019-03-07T11:39:08.04+08:00\"},{\"id\":\"9A2C0823-D0CD-4A45-964D-EDFD2E4D55F9\",\"name\":\"北京天安门\",\"createTime\":\"2018-07-05T09:03:13.727+08:00\",\"updateTime\":\"2018-11-22T20:00:45.383+08:00\"},{\"id\":\"b34ee25a-a422-4096-a3fb-7335bb6a50cd\",\"name\":\"北京西二旗\",\"createTime\":\"2019-03-07T11:39:01.993+08:00\",\"updateTime\":\"2019-03-07T11:39:01.993+08:00\"},{\"id\":\"5AEEE006-B63F-4211-A4CC-C62936C7FCBF\",\"name\":\"成都来福士广场\",\"createTime\":\"2018-07-05T09:04:27.95+08:00\",\"updateTime\":\"2018-07-10T16:20:54.18+08:00\"},{\"id\":\"1bbd0d87-1723-4f87-9547-0ca0a6959a85\",\"name\":\"上海黄埔区国家税局\",\"createTime\":\"2018-07-12T17:20:13.287+08:00\",\"updateTime\":\"2018-08-29T18:21:37.603+08:00\"}]");
        return result;
    }

    @RequestMapping("taxCalendar/getTaxCalendarDataForDisplay")
    @ResponseBody
    public Object getTaxCalendarDataForDisplay(){
        return new ArrayList();
    }

    @RequestMapping("user/getUserOwnOrganization")
    @ResponseBody
    public Object getUserOwnOrganization(){
        Object result = JSONUtils.parse("{\"errors\":null,\"data\":{\"id\":\"A3ECE185-82CC-4375-8E36-0B62137D5367\",\"clientCode\":\"88\",\"name\":\"Bitmain Technologies Limited\",\"code\":\"88\",\"abbreviation\":null,\"parentID\":null,\"taxPayerNumber\":null,\"regionID\":\"110100\",\"parentRegionID\":null,\"structureID\":null,\"industryID\":\"0\",\"isActive\":true,\"createTime\":\"2018-10-26T15:06:58.107+08:00\",\"updateTime\":\"2018-10-26T15:06:58.107+08:00\",\"parentName\":null,\"areaName\":null,\"areaID\":\"e2c4a67d-e7de-4037-939b-e6d437265ab0\",\"businessUnitID\":\"1c5048eb-e886-4fc1-b463-f1efcaedec28\",\"subOrgs\":null,\"sameVehicleroutinglocationList\":null,\"taxControlDiskList\":null,\"legalPersonName\":null,\"manufactureAddress\":\"02-03,15/F,Tower A,Cheung Kei Center,18 Hung Luen Road,Hung Hom,Kowloon,Hong Kong\",\"registerAddress\":\"02-03,15/F,Tower A,Cheung Kei Center,18 Hung Luen Road,Hung Hom,Kowloon,Hong Kong\",\"bankAccountName\":null,\"bankAccountNumber\":null,\"phoneNumber\":\"(00852)28862301\",\"registrationType\":null,\"maximumAmount\":null,\"invoiceEntityType\":null,\"maximumPrintNumber\":null,\"payee\":null,\"reviewer\":null,\"issueBy\":null,\"loginUserAsIssuer\":null,\"districtCode\":null,\"districtName\":null,\"structureName\":null,\"regionName\":null,\"industryName\":null,\"businessUnitName\":null,\"dimensionID\":null,\"dimensionName\":null,\"dimensionValueName\":null,\"dimensionValueID\":null,\"attributeID\":null,\"attributeName\":null,\"isSystemDimension\":false,\"isSyncInputInvoice\":false,\"ratepayer\":null,\"address\":null,\"isLastUseOrgnization\":false,\"foundationDate\":null,\"registrationDate\":null,\"registrationLocation\":null,\"registrationCapital\":null,\"businessAllottedTimeFrom\":null,\"businessAllottedTimeTo\":null,\"legalCode\":null,\"companyCode\":null,\"level\":0,\"interalCustomerID\":\"1072\",\"pLevel\":0,\"maximumSpecialAmount\":null,\"maximumGeneralAmount\":null,\"maximumElectronicAmount\":null,\"canIssueElectricTicket\":false,\"isOverseasCompany\":true,\"enterpriseAccountSetOrgList\":null,\"organizationServiceTemplateGroupList\":null,\"dimensionValueOrgList\":null,\"userRoleList\":null,\"productList\":null,\"authenticationPeriod\":null,\"periodLastUpdateTime\":null,\"periodUpdateResult\":null},\"id\":null,\"result\":true,\"resultMsg\":null,\"returnCode\":0}");
        return result;
    }

    @RequestMapping("taxCalendar/getTaxCalendarUserCompanys/admin")
    @ResponseBody
    public Object getTaxCalendarUserCompanys(){
        Object result = JSONUtils.parse("[{\"id\":\"1782D50E-92EE-4C58-8C15-3D0A49F92793\",\"clientCode\":null,\"name\":\"鄂托克旗哈希云科技有限公司\",\"code\":null,\"abbreviation\":null,\"parentID\":null,\"taxPayerNumber\":null,\"regionID\":null,\"parentRegionID\":null,\"structureID\":null,\"industryID\":null,\"isActive\":false,\"createTime\":\"0001-01-01T00:00:00+08:00\",\"updateTime\":\"0001-01-01T00:00:00+08:00\",\"parentName\":null,\"areaName\":null,\"areaID\":null,\"businessUnitID\":null,\"subOrgs\":null,\"sameVehicleroutinglocationList\":null,\"taxControlDiskList\":null,\"legalPersonName\":null,\"manufactureAddress\":null,\"registerAddress\":null,\"bankAccountName\":null,\"bankAccountNumber\":null,\"phoneNumber\":null,\"registrationType\":null,\"maximumAmount\":null,\"invoiceEntityType\":null,\"maximumPrintNumber\":null,\"payee\":null,\"reviewer\":null,\"issueBy\":null,\"loginUserAsIssuer\":null,\"districtCode\":null,\"districtName\":null,\"structureName\":null,\"regionName\":null,\"industryName\":null,\"businessUnitName\":null,\"dimensionID\":null,\"dimensionName\":null,\"dimensionValueName\":null,\"dimensionValueID\":null,\"attributeID\":null,\"attributeName\":null,\"isSystemDimension\":false,\"isSyncInputInvoice\":null,\"ratepayer\":null,\"address\":null,\"isLastUseOrgnization\":false,\"foundationDate\":null,\"registrationDate\":null,\"registrationLocation\":null,\"registrationCapital\":null,\"businessAllottedTimeFrom\":null,\"businessAllottedTimeTo\":null,\"legalCode\":null,\"companyCode\":null,\"level\":0,\"interalCustomerID\":null,\"pLevel\":0,\"maximumSpecialAmount\":null,\"maximumGeneralAmount\":null,\"maximumElectronicAmount\":null,\"canIssueElectricTicket\":false,\"isOverseasCompany\":false,\"enterpriseAccountSetOrgList\":null,\"organizationServiceTemplateGroupList\":null,\"dimensionValueOrgList\":null,\"userRoleList\":null,\"productList\":null,\"authenticationPeriod\":null,\"periodLastUpdateTime\":null,\"periodUpdateResult\":null}]");
        return result;
    }

}
