package pwc.taxtech.atms.common.pwc.Exception;

/**
 * @version 1.0
 * @program: atms
 * @description: Controller统一处理
 * @author: Kevin
 * @create: 2019-04-22 19:22
 **/

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.propertyeditors.CustomDateEditor;
import org.springframework.ui.Model;
import org.springframework.web.bind.WebDataBinder;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;
import pwc.taxtech.atms.dto.OperationResultDto;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;


@ControllerAdvice
class GloalHander{

    private final static String ERROR_PAGE = "系统错误";
    private static Logger logger = LoggerFactory.getLogger(GloalHander.class);

    @ExceptionHandler(PwcException.class)
    @ResponseBody
    public OperationResultDto handle(Exception e){
        OperationResultDto operationResultDto = new OperationResultDto();
      /*  ModelAndView mv = new ModelAndView();
        mv.addObject("message", e.getMessage());
        mv.setViewName(ERROR_PAGE);*/
      OperationResultDto.error(e.getMessage());
        return operationResultDto;
    }

    @ExceptionHandler(PageException.class)
    @ResponseBody
    public ModelAndView handSql(Exception ex){
        logger.info("-->to error view " + ex.getMessage());
        ModelAndView mv = new ModelAndView();
        if(ex == null){
            mv.addObject("message",ERROR_PAGE);
        }
        mv.setViewName("error.html");
        return mv;
    }

    @ModelAttribute
    //应用到所有@RequestMapping注解方法
    //此处将键值对添加到全局，注解了@RequestMapping的方法都可以获得此键值对
    public void addUser(Model model) {
        //model.addAttribute("pwc.message", "sizegang");
    }

    @InitBinder
    //应用到所有@RequestMapping注解方法，在其执行之前初始化数据绑定器
    //用来设置WebDataBinder，用于自动绑定前台请求参数到Model中。
    public void initBinder(WebDataBinder binder) {
        DateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");
        CustomDateEditor orderDateEditor = new CustomDateEditor(dateFormat, true);
        binder.registerCustomEditor(Date.class, orderDateEditor);
    }

}