package pwc.taxtech.atms.common.util;

/**
 * @version 1.0
 * @program: atms
 * @description:
 * @author: Kevin
 * @create: 2019-04-26 12:31
 **/

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;
import pwc.taxtech.atms.common.EncryptUtil;
import pwc.taxtech.atms.vat.entity.FileUpload;

import javax.mail.*;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.util.*;

@Component
public class JavaEmailUtil {
    private Logger logger = LoggerFactory.getLogger(JavaEmailUtil.class);
    /**
     * 获取邮件内容
     *
     * @param args
     * @throws Exception
     */
    @Value("${email.host}")
    private String host;

    @Value("${email.store.protocol}")
    private String protocol;

    @Value("${email.address}")
    private String email;

    @Value("${email.password}")
    private String email_password;

    @Value("${email.aesKey}")
    private String aesKey;

    public static void main(String[] args) {
       /* EncryptUtil instance = EncryptUtil.getInstance();
        String aesKey = null;
        String password = null;
        try {
            aesKey = instance.getAESKey();
            System.out.println(aesKey);
            password = instance.AESencode("szg8571451", aesKey);
            System.out.println(password);
        } catch (Exception e) {
            e.printStackTrace();
        }
        String _password = instance.AESdecode(password, aesKey);
        System.out.println(_password);*/
        System.out.println(getZeroTime() + " ------" +  System.currentTimeMillis());

    }

    /**
     * @param init 是否数据初始化
     */
    public List<Map<String, Object>> getEmails(boolean init) throws Exception {
        logger.info("taxemail ``````````````````````````````````````````````````````````````````````````````````````````````````");

        EncryptUtil instance = EncryptUtil.getInstance();
        List<Map<String, Object>> emailList = new ArrayList<>();
        Properties props = new Properties();
        //设置邮件接收协议为pop3
        props.setProperty("mail.store.protocol", protocol);
        props.setProperty("mail.pop3.host", host);
        Session session = Session.getInstance(props);
        Store store = session.getStore(protocol);
        //连接要获取数据的邮箱 主机+用户名+密码
        logger.info("pass ``````````````````````````````````````````````````````````````````````````````````````````````````"+ EncryptUtil.AESdecode(email_password, aesKey));

        store.connect(host, email, EncryptUtil.AESdecode(email_password, aesKey));

        logger.info("connect ``````````````````````````````````````````````````````````````````````````````````````````````````"+store);
        Folder folder = store.getFolder("inbox");
        //设置邮件可读可写
        folder.open(Folder.READ_WRITE);

        logger.info("init  ``````````````````````````````````````````````````````````````````````````````````````````````````"+init);
        if (!init) {

            Message[] messages = folder.getMessages();
            logger.info("进入 ``````````````````````````````````````````````````````````````````````````````````````````````````"+messages);
            for (int i = 0; i < messages.length; i++) {
                Map<String, Object> map = new HashMap<>();
                //如果不是初始化，只读取从零点到当前时间的邮件
                if (getZeroTime() < messages[i].getSentDate().getTime() &&
                        messages[i].getSentDate().getTime() < System.currentTimeMillis()) {
                    //解析发件人地址
                    String address = messages[i].getFrom()[0].toString();
                    //logger.warn(address);
                    map.put("address", address);
                    //解析邮件主题
                    String subject = messages[i].getSubject();
                    //logger.warn(subject);
                    map.put("subject", subject);
                    //如果只是纯文本文件情况
                    //String content = (String) messages[i].getContent();
                    //MIME中包含文本情况
                    //getTextMultipart(messages[i]);
                    //MIME中包含图片情况
                    //getPicMultipart(messages[i]);
                    //MIME中包含附件情况
                    //getAttachmentMultipart(messages[i]);
                    //解析综合数据情况
                    map.put("sendDate", messages[i].getSentDate());
                    FileUpload allMultipart = getAllMultipart(messages[i], map);
                    if (allMultipart != null)
                        map.put("attachInfo", allMultipart);
                    int i1 = messages[i].getFrom()[0].toString().indexOf(" <");
                    int i2 = messages[i].getFrom()[0].toString().indexOf(">");
                    try {
                        map.put("from_person", messages[i].getFrom()[0].toString().substring(i1 + 1, i2));
                    } catch (Exception e) {
                        map.put("from_person", "未知发件人");
                        // e.printStackTrace();
                    }
                    //https://mp.weixin.qq.com/s/_tWq8QUl_db-GcUThIoY0Q
                    //https://mp.weixin.qq.com/s/hxZZMhDRHHu4LqkXczMztw'
                    int qqIndex = map.get("content").toString().indexOf("https://mp.weixin.qq.com");
                    if (qqIndex != -1) {
                        map.put("url", map.get("content").toString().substring(qqIndex, qqIndex + 59));
                        map.put("type", "0");
                    } else {
                        map.put("type", "1");
                    }
                }
            }
            folder.close(true);
            store.close();
        } else {
            Message[] messages = folder.getMessages();
            logger.info("进入 ``````````````````````````````````````````````````````````````````````````````````````````````````"+messages);
            for (int i = 0; i < messages.length; i++) {
                Map<String, Object> map = new HashMap<>();
                String address = messages[i].getFrom()[0].toString();
                logger.warn(address);
                map.put("address", address);
                String subject = messages[i].getSubject();
                logger.warn(subject);
                map.put("subject", subject);
                map.put("sendDate", messages[i].getSentDate());
                FileUpload allMultipart = getAllMultipart(messages[i], map);
                if (allMultipart != null)
                    map.put("attachInfo", allMultipart);
                int i1 = messages[i].getFrom()[0].toString().indexOf(" <");
                int i2 = messages[i].getFrom()[0].toString().indexOf(">");
                try {
                    map.put("from_person", messages[i].getFrom()[0].toString().substring(i1 + 1, i2 ));
                } catch (Exception e) {
                    map.put("from_person", "未知发件人");
                    // e.printStackTrace();
                }
                int qqIndex = map.get("content").toString().indexOf("https://mp.weixin.qq.com");
                if (qqIndex != -1) {
                    map.put("url", map.get("content").toString().substring(qqIndex, qqIndex + 49));
                    map.put("type", "0");
                } else {
                    map.put("type", "1");
                }
                emailList.add(map);
            }
            folder.close(true);
            store.close();
        }
        return emailList;
    }

    public static Long getZeroTime() {
        long current = System.currentTimeMillis();//当前时间毫秒数
        return current / (1000 * 3600 * 24) * (1000 * 3600 * 24) - TimeZone.getDefault().getRawOffset();//今天零点零分零秒的毫秒数
    }

    /**
     * 解析综合数据
     * @param part
     * @throws Exception
     */
    private FileUpload getAllMultipart(Part part, Map map) throws Exception {
        String contentType = part.getContentType();
        InputStream is;
        String fileName;
        int index = contentType.indexOf("name");
        boolean conName = false;
        if (index != -1) {
            conName = true;
        }
        //判断part类型
        if (part.isMimeType("text/plain") && !conName) {
            map.put("content", part.getContent());
        } else if (part.isMimeType("text/html") && !conName) {
            map.put("content", part.getContent());
        } else if (part.isMimeType("multipart/*")) {
            Multipart multipart = (Multipart) part.getContent();
            int counts = multipart.getCount();
            for (int i = 0; i < counts; i++) {
                //递归获取数据
                getAllMultipart(multipart.getBodyPart(i), map);
                //附件可能是截图或上传的(图片或其他数据)
                if (multipart.getBodyPart(i).getDisposition() != null) {
                    //附件为截图
                    if (multipart.getBodyPart(i).isMimeType("image/*")) {
                        is = multipart.getBodyPart(i)
                                .getInputStream();
                        String name = multipart.getBodyPart(i).getFileName();

                        //截图图片
                        if (name.startsWith("=?")) {
                            try {
                                fileName = name.substring(name.lastIndexOf(".") - 1, name.lastIndexOf("?="));
                            } catch (Exception ex) {
                                fileName = name;
                            }
                        } else {
                            //上传图片
                            fileName = name;
                        }
                    } else {
                        //其他附件
                        is = multipart.getBodyPart(i)
                                .getInputStream();
                        fileName = multipart.getBodyPart(i).getFileName();
                    }
                    // 将附件上传至文件服务器
                    /*ByteArrayOutputStream byteArrayOutputStream = new ByteArrayOutputStream();
                    byte[] buff = new byte[100]; //buff用于存放循环读取的临时数据
                    int rc = 0;
                    while ((rc = is.read(buff, 0, 100)) > 0) {
                        byteArrayOutputStream.write(buff, 0, rc);
                    }
                    byte[] in_b = byteArrayOutputStream.toByteArray(); //in_b为转换之后的结果
                    if (in_b != null)*/
                    try {
                        //这里可以将我们的文件上传到文件服务器，在这里上传报错了，先注释掉
                        //FileUpload fileUpload = SpringContextUtil.didiFileUploadService.uploadFile(multipartFile, fileName, "邮箱附件");
                        return null;
                    } catch (Exception e) {
                        return null;
                    }
                }
            }
        } else if (part.isMimeType("message/rfc822")) {
            getAllMultipart((Part) part.getContent(), map);
        }
        return null;
    }

    /**
     * 解析附件内容
     *
     * @param part
     * @throws Exception
     */
    private static void getAttachmentMultipart(Part part) throws Exception {
        if (part.isMimeType("multipart/*")) {
            Multipart multipart = (Multipart) part.getContent();
            int count = multipart.getCount();
            for (int i = 0; i < count; i++) {
                BodyPart bodyPart = multipart.getBodyPart(i);
                if (bodyPart.getDisposition() != null) {
                    InputStream is = bodyPart.getInputStream();
                    FileOutputStream fos = new FileOutputStream("路径+文件名");
                    int len = 0;
                    byte[] bys = new byte[1024];
                    while ((len = is.read(bys)) != -1) {
                        fos.write(bys, 0, len);
                    }
                    fos.close();
                }
            }
        }

    }

    /**
     * 解析图片内容
     *
     * @param part
     * @throws Exception
     */
    private static void getPicMultipart(Part part) throws Exception {
        if (part.isMimeType("multipart/*")) {
            Multipart multipart = (Multipart) part.getContent();
            int count = multipart.getCount();
            for (int i = 0; i < count; i++) {
                BodyPart bodyPart = multipart.getBodyPart(i);
                if (bodyPart.isMimeType("image/*")) {
                    InputStream is = bodyPart.getInputStream();
                    FileOutputStream fos = new FileOutputStream("路径+文件名");
                    int len = 0;
                    byte[] bys = new byte[1024];
                    while ((len = is.read(bys)) != -1) {
                        fos.write(bys, 0, len);
                    }
                    fos.close();
                }
            }
        }
    }

    /**
     * 解析文本内容
     *
     * @param part
     * @throws Exception
     */
    private static void getTextMultipart(Part part) throws Exception {
        if (part.isMimeType("text/html")) {
            String content = (String) part.getContent();
            System.out.println(content);
        } else if (part.isMimeType("text/plain")) {
            String content = (String) part.getContent();
            System.out.println(content);
        }
    }
}