package pwc.taxtech.atms.dto.backlogManage;

import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import pwc.taxtech.atms.common.util.PwCIdSerialize;
import pwc.taxtech.atms.constant.enums.BackLogEnum;
import pwc.taxtech.atms.vat.entity.BacklogGroup;

import java.io.Serializable;
import java.util.Date;

public class BacklogGroupResult extends BacklogGroup implements Serializable {


    private static final long serialVersionUID = -4999504725632036073L;
    @JsonSerialize(using = PwCIdSerialize.class)
    private Long id;

    private String orgName;

    private String businessLine;

    private String  createUserName;

    private String month;

    private String status;

    private Date chinaWarnStartTime;

    private Date chinaWarnEndTime;

    public String getStatusStr() {
        return BackLogEnum.GroupCommonStatus.MAPPING.get(this.getStatus());
    }

    public Date getChinaWarnStartTime() {
        return chinaWarnStartTime;
    }

    public void setChinaWarnStartTime(Date chinaWarnStartTime) {
        this.chinaWarnStartTime = chinaWarnStartTime;
    }

    public Date getChinaWarnEndTime() {
        return chinaWarnEndTime;
    }

    public void setChinaWarnEndTime(Date chinaWarnEndTime) {
        this.chinaWarnEndTime = chinaWarnEndTime;
    }

    public String getMonth() {
        return month;
    }

    public void setMonth(String month) {
        this.month = month;
    }

    public String getStatus() {
        return status;
    }

    public void setStatus(String status) {
        this.status = status;
    }

    public String getGenerateTypeStr(){
        return BackLogEnum.GenerateType.MAPPING.get(this.getGenerateType());
    }

    public String getCreateUserName() {
        return createUserName;
    }

    public void setCreateUserName(String createUserName) {
        this.createUserName = createUserName;
    }

    @Override
    public Long getId() {
        return id;
    }

    @Override
    public void setId(Long id) {
        this.id = id;
    }

    public String getOrgName() {
        return orgName;
    }

    public void setOrgName(String orgName) {
        this.orgName = orgName;
    }

    public String getBusinessLine() {
        return businessLine;
    }

    public void setBusinessLine(String businessLine) {
        this.businessLine = businessLine;
    }
}
