﻿infrastructureModule.controller('internationTaxController',
    ['$log', '$http', '$q', '$scope', '$translate', '$timeout', 'SweetAlert', '$compile', 'interactionService', '$filter', 'Upload', 'apiInterceptor',
        function ($log, $http, $q, $scope, $translate, $timeout, SweetAlert, $compile, interactionService, $filter, Upload, apiInterceptor) {

            $scope.localData = {};
            $scope.pagingOptions = {
                totalItems: 10,  //总数据
            };
            $scope.loadMainData = function () {
                var config = {
                    params: {}
                };
                interactionService.getListData(config).then(function (data, status, headers) {
                    if (status === 204) {
                        SweetAlert.warning("没有数据");
                        return;
                    }
                    $scope.dataGridUpdate(data);
                })
            };
            $scope.dataGridUpdate = function (_data) {
                $scope.localData = _data.data;
                $scope.pagingOptions = {
                    totalItems: $scope.localData.length,  //总数据
                };
                $scope.dataGridOptions = {
                    // dataSource: {
                    //     store: $scope.localData.items,
                    //     reshapeOnPush: true
                    // },
                    bindingOptions: {
                        dataSource: 'localData',
                    },
                    // repaintChangesOnly: true,
                    // twoWayBindingEnabled: true,
                    showBorders: true,
                    paging: {
                        enable: true,
                        pageIndex: 0,
                        pageSize: 10
                    },
                    pager: {
                        allowedPageSizes: 5,
                        infoText: "当前 {0}页 /共 {1}页 ({2} 项)",
                        showInfo: true,
                        showNavigationButtons: true,
                        showPageSizeSelector: true,
                        visible: true
                    },
                    searchPanel: {//查询
                        highlightCaseSensitive: true,
                        highlightSearchText: true,
                        searchVisibleColumnsOnly: false,
                        text: "",
                        width: 518,
                        visible: true,
                        placeholder: $translate.instant('Search'),
                    },
                    sorting: {//排序
                        ascendingText: "Sort Ascending",
                        clearText: "Clear Sorting",
                        descendingText: "Sort Descending",
                        mode: "single"
                    },
                    'export': {
                        allowExportSelectedData: false,//允许选择导出
                        customizeExcelCell: null,
                        enabled: true,//允许导出
                        excelFilterEnabled: false,
                        excelWrapTextEnabled: false,
                        fileName: "shareManage",//名字
                        ignoreExcelErrors: true,

                    },
                    showRowLines: true,
                    columnAutoWidth: true,
                    allowColumnReordering: true,
                    columns: [
                        /*{
                            dataField: "id",
                            caption: $translate.instant('SequenceNumber'),
                            allowHeaderFiltering: true,
                            cellTemplate: function (container, options) {
                                try {

                                    var style =  options.data.essenceFlag == 1 ? '' : 'style="color:#999"';
                                    if (options.data.id) {
                                        $('<span ' + style + '>').text(options.data.id).appendTo(container);
                                    } else {
                                        $('<span>').text("").appendTo(container);
                                    }
                                } catch (e) {
                                    $log.error(e);
                                }
                            }
                        },*/
                        {
                            dataField: "title",
                            caption: $translate.instant('ContentTitle'),
                            show: false,
                            allowHeaderFiltering: true,
                            cellTemplate: function (container, options) {
                                try {

                                    var style = options.data.essenceFlag == 1 ? '' : 'style="color:#999"';
                                    if (options.data.id) {
                                        $('<span ' + style + '>').text(options.data.title).appendTo(container);
                                    } else {
                                        $('<span>').text("").appendTo(container);
                                    }
                                } catch (e) {
                                    $log.error(e);
                                }
                            }
                        },
                        {
                            dataField: "type",
                            caption: $translate.instant('DataCheckType'),
                            allowHeaderFiltering: true,
                            cellTemplate: function (container, options) {
                                try {

                                    var style = options.data.essenceFlag == 1 ? '' : 'style="color:#999"';
                                    $('<span ' + style + '>').text($scope.emailType(options.data.type)).appendTo(container);

                                } catch (e) {
                                    $log.error(e);
                                }
                            }
                        },
                        {
                            dataField: "createBy",
                            caption: $translate.instant('Creator'),
                            allowHeaderFiltering: true,
                            cellTemplate: function (container, options) {
                                try {
                                    var style = options.data.essenceFlag == 1 ? '' : 'style="color:#999"';
                                    if (options.data.createBy) {
                                        $('<span ' + style + '>').text(options.data.createBy).appendTo(container);
                                    } else {
                                        $('<span>').text("").appendTo(container);
                                    }
                                } catch (e) {
                                    $log.error(e);
                                }
                            }
                        },
                        {
                            dataField: "createTime",
                            caption: $translate.instant('CreatedTime'),
                            allowHeaderFiltering: true,
                            cellTemplate: function (container, options) {
                                try {

                                    var style = options.data.essenceFlag == 1 ? '' : 'style="color:#999"';
                                    if (options.data.createTime) {
                                        $('<span ' + style + '>').text($filter('date')(options.data.createTime, 'yyyy-MM-dd')).appendTo(container);
                                    } else {
                                        $('<span>').text('').appendTo(container);
                                    }
                                } catch (e) {
                                    $log.error(e);
                                }
                            }
                        },
                        {
                            dataField: "essenceFlag",
                            caption: $translate.instant('IsEssence'),
                            allowHeaderFiltering: true,
                            cellTemplate: function (container, options) {
                                try {
                                    var style = options.data.essenceFlag == 1 ? '' : 'style="color:#999"';
                                    $('<span ' + style + '>').text($scope.flagType(options.data.essenceFlag)).appendTo(container);

                                } catch (e) {
                                    $log.error(e);
                                }
                            }
                        },
                        {
                            dataField: "topFlag",
                            caption: $translate.instant('IsTop'),
                            allowHeaderFiltering: true,
                            cellTemplate: function (container, options) {
                                try {
                                    var style = options.data.essenceFlag == 1 ? '' : 'style="color:#999"';

                                    $('<span ' + style + '>').text($scope.flagType(options.data.topFlag)).appendTo(container);

                                } catch (e) {
                                    $log.error(e);
                                }
                            }
                        },
                        {
                            dataField: "delFlag",
                            caption: $translate.instant('IsDisplay'),
                            allowHeaderFiltering: true,
                            cellTemplate: function (container, options) {
                                try {
                                    var style = options.data.essenceFlag == 1 ? '' : 'style="color:#999"';

                                    $('<span ' + style + '>').text($scope.delType(options.data.delFlag)).appendTo(container);

                                } catch (e) {
                                    $log.error(e);
                                }
                            }
                        },
                        {
                            dataField: "operation",
                            caption: $translate.instant('Operation'),
                            allowHeaderFiltering: false,
                            cellTemplate: function (container, options) {
                                try {
                                    var eventTarget = $('<a style="color:#506bf7;" data-id="' + options.data.id + '" href="javascript:void(0)"><span>' + $translate.instant("Edit") + '</span></a><span style="width: 10px;display: inline-block"></span>');
                                    eventTarget.off('click').on('click', function () {
                                        $scope.openEditPop(options.data);
                                    });
                                    var pdf = $('<a style="color:#506bf7;" href="javascript:void(0)" ><span>' + $translate.instant("Preview") + '</span></a><span style="width: 10px;display: inline-block"></span>');
                                    pdf.off('click').on('click', function () {
                                        $scope.viewPdf(options.data);
                                    });
                                    var eventTargetDel = $('<a style="color:#506bf7;" data-id="' + options.data.id + '" href="javascript:void(0)"><span>' + $translate.instant("cellCommentDelete") + '</span></a><span style="width: 10px;display: inline-block"></span>');
                                    eventTargetDel.off('click').on('click', function () {
                                        $scope.deleteInternational(options.data.id);
                                    });
                                    container.append(eventTarget).append(pdf).append(eventTargetDel);

                                } catch (e) {
                                    $log.error(e);
                                }
                            }
                        },
                    ],
                    rowAlternationEnabled: false  //单双行颜色
                };
            };

            $scope.deleteInternational = function (id) {
                SweetAlert.swal({
                        title: '确定删除吗？',
                        text: '',
                        type: "warning",
                        showCancelButton: true,
                        confirmButtonColor: "#DD6B55",
                        confirmButtonText: $translate.instant('Confirm'),
                        cancelButtonText: $translate.instant('Cancel'),
                        closeOnConfirm: false,
                        closeOnCancel: true
                    },
                    function (isConfirm) {
                        if (isConfirm) {
                            interactionService.deleteInternationById(id).success(function (res) {
                                if (res.result == true) {
                                    $scope.loadMainData();
                                    SweetAlert.success($translate.instant('DeleteSuccess'));
                                } else {
                                    SweetAlert.error(res.resultMsg);
                                }
                            });
                        } else {

                        }
                    });
            };

            var pdfView = function (rowData) {
                if (rowData.type == 0) {//手动添加的不支持预览功能
                    SweetAlert.warning("不支持在线预览");

                } else {
                    if (rowData.attachUrl == null) {
                        SweetAlert.warning("不支持在线预览");
                        return;
                    }
                    //  $scope.pdfUrl = apiInterceptor.vatWebApiHostUrl + '/InternationSystem/pdfView?id=' + rowData.attachUrl;
                    // $('#pdfModal').modal();
                    //获取远程文件url
                    function start() {
                        return new Promise(function (resolve, reject) {
                            resolve('start');
                        });
                    }

                    start().then(function (start) {
                        return interactionService.getRemotePdfUrl(rowData.attachUrl);
                    }).then(function (res) {
                        if (res.data == null) {
                            SweetAlert.warning("pdf加载失败");
                            return;
                        }
                        $scope.openPdfPreviewPop(res.data)
                    })
                }
            };

            /*  $scope.operationStyle = function () {
                  $('.TDL-pdf-paging-btn-prev').css({
                      top: '0',
                      left: '50%',
                      transform: 'rotate(90deg)'
                  })
                  ;
                  $('.TDL-pdf-preview-pop').css({
                      background: 'none'
                  })
                  $('.TDL-pdf-paging-btn-next').css({
                      top: '85%',
                      left: '50%',
                      transform: 'rotate(90deg)'
                  });
              }*/


            $scope.getTableHeight = function () {
                var row_height = $("table").find("tr").height();
                if (row_height) {
                    return {
                        height: (row_height * 12 + 100) + "px"
                    }
                }
            };

            $scope.flagType = function (type) {
                if (type == 1) {
                    return "是";
                } else {
                    return "否";
                }
            };

            $scope.delType = function (type) {
                if (type == 1) {
                    return "不显示";
                } else {
                    return "显示";
                }
            };

            $scope.emailType = function (type) {
                if (type == 0) {
                    return "手动添加";
                } else {
                    return "PDF上传";
                }
            };
            //取消
            var cancelDocFileType = function () {
                console.log("cancelDocFileType")
            };

            $scope.editModel = {
                "id": null,//主键id
                "essenceFlag": null,
                "topFlag": null,
                "delFlag": null,

            };
            //----------------------kevin insert -------------------------------
            $scope.operation = {};
            $scope.editor1 = "editor1";
            $scope.addShare = function () {
                $scope.textType = true;
                endProcess();
                $scope.operation.flag = constant.shareTypeFlag.addInternationTax;
                $scope.operation.type = 0;//新建国际税制
                if ($scope.$editor == undefined) {
                    $scope.$editor = $scope.editorInit('editor1', 0);
                }
                $('#addShareModal').modal();
            };

            //上传PDF国际税制
            $scope.addPdfUpload = function () {
                $scope.textType = false;
                $scope.pdfObj = null;
                endProcess();
                $scope.operation.flag = constant.shareTypeFlag.addPDFInternationTax;
                $scope.operation.type = 0;//新建国际税制
                $('#addShareModal').modal();
            };

            $scope.standardFileChange = function ($files, $file, $newFiles, $duplicateFiles, $invalidFiles, $event) {
                console.log($files, $file, $newFiles, $duplicateFiles, $invalidFiles, $event);
                if ($newFiles[0]) {
                    $scope.pdfObj = $newFiles[0];
                }
                $scope.share.pdfName = $file.name;
                $scope.share.pdfSize = renderSize($file.size);
            };

            //上传PDF国际税制
            var pdfAddSubmit = function () {

                if ($scope.pdfObj == undefined || $scope.pdfObj == null || $scope.pdfObj == '') {
                    SweetAlert.warning("请上传PDF");
                    return false;
                }
                var content = {
                    title: $scope.share.title,
                    tag: $scope.share.tag,
                    topFlag: $scope.share.topFlag == true ? 1 : 0,
                    delFlag: $scope.share.delFlag == true ? 1 : 0,
                    essenceFlag: $scope.share.essenceFlag == true ? 1 : 0,
                    pdfName: $scope.share.pdfName,
                    pdfSize: $scope.share.pdfSize
                };
                swal({
                    title: "PDF上传中!",
                    showConfirmButton: false,
                    imageUrl: "loading.gif",
                    showCancelButton: false,
                });
                Upload.upload(
                    {
                        url: apiInterceptor.webApiHostUrl + "/InternationSystem/pdfUpload",
                        file: $scope.pdfObj,
                        data: content,
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            Authorization: apiInterceptor.tokenType + ' ' + apiInterceptor.apiToken(),
                            withCredentials: true
                        },
                        withCredentials: true
                    })
                    .progress(function (evt) {
                    })
                    .success(function (data, status, headers, config) {
                        if (data.result) {
                            SweetAlert.success("上传PDF成功");
                            $scope.loadMainData();
                        } else {
                            SweetAlert.success("上传PDF失败");
                        }
                    })
                    .error(function (data, status, headers, config) {
                        SweetAlert.error("系统错误");
                    })
            };

            //PDF编辑提交
            var pdfEditSubmit = function () {
                if (!$scope.share.pdfName && !$scope.share.pdfSize) {
                    SweetAlert.warning("验证", "请上传pdf");
                    return false;
                }
                var content = angular.copy($scope.share);
                checkboxConvert.to(content);
                delete content.content;
                delete content.createTime;
                delete content.updateTime;
                swal({
                    title: "PDF修改中!",
                    showConfirmButton: false,
                    imageUrl: "loading.gif",
                    showCancelButton: false,
                });
                Upload.upload(
                    {
                        url: apiInterceptor.webApiHostUrl + "/InternationSystem/pdfUploadEdit",
                        file: $scope.pdfObj,
                        data: content,
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            Authorization: apiInterceptor.tokenType + ' ' + apiInterceptor.apiToken(),
                            withCredentials: true
                        },
                        withCredentials: true
                    })
                    .progress(function (evt) {
                    })
                    .success(function (data, status, headers, config) {
                        if (data.result) {
                            SweetAlert.success("修改PDF成功");
                            $scope.loadMainData();
                        } else {
                            SweetAlert.success("修改PDF失败");
                        }
                    })
                    .error(function (data, status, headers, config) {
                        SweetAlert.error("系统错误");
                    })
            };

            var openEditPop = function (rowData) {
                if (rowData.type == 1) {
                    editPDFOpen(rowData);
                } else if (rowData.type == 0) {
                    editShareOpen(rowData)
                }

            };

            var editPDFOpen = function (rowData) {
                $scope.textType = false;
                endProcess();
                $scope.pdfObj = null;
                $scope.operation.flag = constant.shareTypeFlag.editPDFInternationTax;
                $scope.operation.type = 1;//编辑
                interactionService.getInternationTaxById(rowData.id).success(function (res) {
                    if (res.data) {
                        $scope.share = res.data;
                        checkboxConvert.come(res.data);
                        $scope.shareTag.forEach(function (s, i) {
                            if (s.tagname == res.data.tag) {
                                s.visible = true;
                            }
                        });
                    } else {
                        SweetAlert.error(res.resultMsg);
                    }

                    $('#addShareModal').modal();
                });

            };


            var editShareOpen = function (rowData) {
                $scope.textType = true;
                endProcess();
                if ($scope.$editor == undefined) {
                    $scope.$editor = $scope.editorInit('editor1', 0);
                }
                $scope.operation.flag = constant.shareTypeFlag.editInternationTax;
                $scope.operation.type = 1;//编辑
                interactionService.getInternationTaxById(rowData.id).success(function (res) {
                    if (res.data) {
                        $scope.share = res.data;
                        checkboxConvert.come(res.data);
                        $scope.richText.write($scope.share.content);
                        $scope.shareTag.forEach(function (s, i) {
                            if (s.tagname == res.data.tag) {
                                s.visible = true;
                            }
                        });
                    } else {
                        SweetAlert.error(res.resultMsg);
                    }

                    $('#addShareModal').modal();
                });

            };
            $scope.submit = function (type) {

                if ($scope.textType == true) {
                    submitShare(type);
                } else {
                    submitPDF(type);
                }

            };
            //新增文本
            var submitShare = function (type) {
                if (!$scope.share.title) {
                    SweetAlert.warning("验证", "标题不能为空");
                    $('#title').focus();

                    return false;
                }
                if (!$scope.share.tag) {
                    SweetAlert.warning("验证", "标签不能为空");
                    $('#tag').focus();
                    return false;
                }
                if ($scope.richText.read().length <= 11) {
                    SweetAlert.warning("验证", "请最少输入5个字内容");
                    return false;
                }


                $('#addShareModal').modal('hide');
                if (type == 0) {//新增
                    var share = {
                        title: $scope.share.title,
                        tag: $scope.share.tag,
                        topFlag: $scope.share.topFlag == true ? 1 : 0,
                        content: $scope.richText.read(),
                        delFlag: $scope.share.delFlag == true ? 1 : 0,
                        essenceFlag: $scope.share.essenceFlag == true ? 1 : 0
                    };
                    interactionService.addInternationTax(share).success(function (res) {
                        if (res.result == true) {
                            SweetAlert.success(res.data);
                            $scope.loadMainData();
                        } else {
                            SweetAlert.error(res.resultMsg);
                        }
                    })
                } else {//编辑
                    $scope.share.content = $scope.richText.read();
                    var copyShare = angular.copy($scope.share);
                    checkboxConvert.to(copyShare);
                    delete copyShare.createTime;
                    delete copyShare.updateTime;
                    interactionService.editInternationTax(copyShare).success(function (res) {
                        if (res.result == true) {
                            SweetAlert.success(res.data);
                            $scope.loadMainData();
                        } else {
                            SweetAlert.error(res.resultMsg);
                        }
                    });
                }
            };

            //新增pdf
            var submitPDF = function (type) {
                if (!$scope.share.title) {
                    SweetAlert.warning("验证", "标题不能为空");
                    $('#title').focus();

                    return false;
                }
                if (!$scope.share.tag) {
                    SweetAlert.warning("验证", "标签不能为空");
                    $('#tag').focus();
                    return false;
                }
                if (!$scope.share.pdfName && !$scope.share.pdfSize) {
                    SweetAlert.warning("验证", "请上传pdf");
                    $('#pdfObj').focus();
                    return false;
                }

                $('#addShareModal').modal('hide');
                if (type == 0) {//新增
                    pdfAddSubmit();
                } else {//编辑
                    pdfEditSubmit();
                }
            };


            var checkboxConvert = {
                come: function (data) {
                    if (data.delFlag == 1) {
                        $scope.share.delFlag = true;
                    } else {
                        $scope.share.delFlag = false;
                    }
                    if (data.essenceFlag == 1) {
                        $scope.share.essenceFlag = true;
                    } else {
                        $scope.share.essenceFlag = false;
                    }
                    if (data.topFlag == 1) {
                        $scope.share.topFlag = true;
                    } else {
                        $scope.share.topFlag = false;
                    }
                },
                to: function (copyShare) {
                    if ($scope.share.delFlag == true) {
                        copyShare.delFlag = 1;
                    } else {
                        copyShare.delFlag = 0;
                    }
                    if ($scope.share.essenceFlag == true) {
                        copyShare.essenceFlag = 1;
                    } else {
                        copyShare.essenceFlag = 0;
                    }
                    if ($scope.share.topFlag == true) {
                        copyShare.topFlag = 1;
                    } else {
                        copyShare.topFlag = 0;
                    }
                }
            };
            var endProcess = function () {
                $scope.share = {};
                if ($scope.richText != undefined) {
                    $scope.richText.write('');
                }
                //加标签数据, 国际税的标签是2
                interactionService.getTagList(constant.tagTypeList.interactionInternationSystem).then(function (data, status, headers) {
                    if (data.data != null) {
                        var data = data.data;
                        $scope.shareTag = [];
                        data.forEach(function (value, i) {
                            $scope.shareTag.push(new pwcTag(value.id, value.tagname));
                        });
                    } else {
                        SweetAlert.error("加载标签列表失败");
                    }
                });
                $scope.tagSet = false;
                $scope.tagOperation = "添加标签";
            };
            var initModalStyle = function () {
                $('#modalStyle').width(window.screen.width - 300);
            };

            function pwcTag(id, tagname, visible) {
                this.tagname = tagname;
                this.id = id,
                    this.visible = visible != undefined ? visible : false;
            }

            $scope.deletePDF = function () {

                $scope.pdfObj = '';
                $scope.share.pdfName = '';
                $scope.share.pdfSize = '';
            };

            $scope.createTag = function () {
                if ($scope.tagSet == false || $scope.tagSet == undefined) {
                    $scope.tagSet = true;
                    $("#tagInput").show();
                    $scope.tagOperation = "确定";
                } else {
                    if ($scope.share.addTag == "" || $scope.share.addTag == null || $scope.share.addTag == undefined) {
                        SweetAlert.info("输入标签不能为空");
                        return false;
                    }
                    interactionService.addTagSubmit($scope.share.addTag, 2).then(function (data, status, headers) {
                        if (data.resultMsg = "success") {
                            $scope.shareTag.push(new pwcTag(new Date().getTime(), $scope.share.addTag));
                            $scope.share.addTag = '';

                        } else {
                            SweetAlert.error("标签添加失败");
                        }
                        $scope.tagSet = false;
                        $scope.tagOperation = "添加标签";
                        $("#tagInput").hide();
                    })
                }
            };

            var checkUserPermission = function () {

                var list = [];
                $scope.hasTagPermission = false;
                var temp = constant.InteractionPermission;
                list.push(temp.tagOperate.code);
                $scope.$root.checkUserPermissionList(list).success(function (data) {
                    $scope.hasTagPermission = data[temp.tagOperate.code];
                });
            };

            function renderSize(filesize) {
                if (null == filesize || filesize == '') {
                    return "0 b";
                }
                var unitArr = ["b", "KB", "MB", "GB", "TB", "PB", "EB", "ZB", "YB"];
                var index = 0;
                var srcsize = parseFloat(filesize);
                index = Math.floor(Math.log(srcsize) / Math.log(1024));
                var size = srcsize / Math.pow(1024, index);
                size = size.toFixed(2);//保留的小数位数
                return size + unitArr[index];
            }

//----------------------insert end -------------------------------

//----------------------taxation----basic-end-------------------------------
            (function initialize() {
                $scope.loadMainData();
                initModalStyle();
                checkUserPermission();
                //注册方法
                $scope.openEditPop = openEditPop;
                $scope.viewPdf = pdfView;
                $scope.cancelDocFileType = cancelDocFileType;
            })();
        }])
;
