﻿infrastructureModule.controller('shareManageController',
    ['$log', '$http', '$q', '$scope', '$translate', '$timeout', 'SweetAlert', '$compile', 'interactionService', '$filter',
        function ($log, $http, $q, $scope, $translate, $timeout, SweetAlert, $compile, interactionService, $filter) {

            $scope.localData = {};
            $scope.pagingOptions = {
                totalItems: 10,  //总数据
            };
            $scope.loadMainData = function () {

                var config = {
                    params: {}
                };
                interactionService.getMainList(config).then(function (data, status, headers) {
                    if (status === 204) {
                        SweetAlert.warning("没有数据");
                        return;
                    }
                    $scope.dataGridUpdate(data);
                })
            };
            $scope.dataGridUpdate = function (_data) {
                $scope.localData = _data;
                $scope.pagingOptions = {
                    totalItems: $scope.localData.length,  //总数据
                };

                $scope.dataGridOptions = {
                    // dataSource: {
                    //     store: $scope.localData.items,
                    //     reshapeOnPush: true
                    // },
                    bindingOptions: {
                        dataSource: 'localData',
                    },
                    // repaintChangesOnly: true,
                    // twoWayBindingEnabled: true,
                    showBorders: true,
                    paging: {
                        enable: true,
                        pageIndex: 0,
                        pageSize: 10
                    },
                    pager: {
                        allowedPageSizes: 5,
                        infoText: "当前 {0}页 /共 {1}页 ({2} 项)",
                        showInfo: true,
                        showNavigationButtons: true,
                        showPageSizeSelector: true,
                        visible: true
                    },
                    searchPanel: {//查询
                        highlightCaseSensitive: true,
                        highlightSearchText: true,
                        searchVisibleColumnsOnly: false,
                        text: "",
                        width: 518,
                        visible: true,
                        placeholder: $translate.instant('Search'),
                    },
                    sorting: {//排序
                        ascendingText: "Sort Ascending",
                        clearText: "Clear Sorting",
                        descendingText: "Sort Descending",
                        mode: "single"
                    },
                    'export': {
                        allowExportSelectedData: false,//允许选择导出
                        customizeExcelCell: null,
                        enabled: true,//允许导出
                        excelFilterEnabled: false,
                        excelWrapTextEnabled: false,
                        fileName: "shareManage",//名字
                        ignoreExcelErrors: true,

                    },
                    showRowLines: true,
                    columnAutoWidth: true,
                    allowColumnReordering: true,
                    columns: [
                        /*{
                            dataField: "id",
                            caption: $translate.instant('SequenceNumber'),
                            allowHeaderFiltering: true,
                            cellTemplate: function (container, options) {
                                try {

                                    var style =  options.data.essenceFlag == 1 ? '' : 'style="color:#999"';
                                    if (options.data.id) {
                                        $('<span ' + style + '>').text(options.data.id).appendTo(container);
                                    } else {
                                        $('<span>').text("").appendTo(container);
                                    }
                                } catch (e) {
                                    $log.error(e);
                                }
                            }
                        },*/
                        {
                            dataField: "title",
                            caption: $translate.instant('ShareTitle'),
                            show: false,
                            allowHeaderFiltering: true,
                            cellTemplate: function (container, options) {
                                try {

                                    var style = options.data.essenceFlag == 1 ? '' : 'style="color:#999"';
                                    if (options.data.title) {
                                        $('<span ' + style + '>').text(options.data.title).appendTo(container);
                                    } else {
                                        $('<span>').text("").appendTo(container);
                                    }
                                } catch (e) {
                                    $log.error(e);
                                }
                            }
                        },
                        {
                            dataField: "type",
                            caption: $translate.instant('ShareType'),
                            allowHeaderFiltering: true,
                            cellTemplate: function (container, options) {
                                try {

                                    var style = options.data.essenceFlag == 1 ? '' : 'style="color:#999"';
                                    $('<span ' + style + '>').text($scope.emailType(options.data.type)).appendTo(container);

                                } catch (e) {
                                    $log.error(e);
                                }
                            }
                        },

                        {
                            dataField: "url",
                            caption: $translate.instant('url'),
                            allowHeaderFiltering: true,
                            cellTemplate: function (container, options) {
                                try {

                                    var style = options.data.essenceFlag == 1 ? '' : 'style="color:#999"';
                                    if (options.data.url) {
                                        $('<span ' + style + '>').text(options.data.url).appendTo(container);
                                    } else {
                                        $('<span>').text("").appendTo(container);
                                    }
                                } catch (e) {
                                    $log.error(e);
                                }
                            }
                        },
                        {
                            dataField: "createBy",
                            caption: $translate.instant('Creator'),
                            allowHeaderFiltering: true,
                            cellTemplate: function (container, options) {
                                try {
                                    var style = options.data.essenceFlag == 1 ? '' : 'style="color:#999"';
                                    if (options.data.createBy) {
                                        $('<span ' + style + '>').text(options.data.createBy).appendTo(container);
                                    } else {
                                        $('<span>').text("").appendTo(container);
                                    }
                                } catch (e) {
                                    $log.error(e);
                                }
                            }
                        },
                        {
                            dataField: "createTime",
                            caption: $translate.instant('CreatedTime'),
                            allowHeaderFiltering: true,
                            cellTemplate: function (container, options) {
                                try {

                                    var style = options.data.essenceFlag == 1 ? '' : 'style="color:#999"';
                                    if (options.data.createTime) {
                                        $('<span ' + style + '>').text($filter('date')(options.data.createTime, 'yyyy-MM-dd')).appendTo(container);
                                    } else {
                                        $('<span>').text('').appendTo(container);
                                    }
                                } catch (e) {
                                    $log.error(e);
                                }
                            }
                        },
                        {
                            dataField: "essenceFlag",
                            caption: $translate.instant('IsEssence'),
                            allowHeaderFiltering: true,
                            cellTemplate: function (container, options) {
                                try {
                                    var style = options.data.essenceFlag == 1 ? '' : 'style="color:#999"';
                                    $('<span ' + style + '>').text($scope.flagType(options.data.essenceFlag)).appendTo(container);

                                } catch (e) {
                                    $log.error(e);
                                }
                            }
                        },
                        {
                            dataField: "topFlag",
                            caption: $translate.instant('IsTop'),
                            allowHeaderFiltering: true,
                            cellTemplate: function (container, options) {
                                try {
                                    var style = options.data.essenceFlag == 1 ? '' : 'style="color:#999"';

                                    $('<span ' + style + '>').text($scope.flagType(options.data.topFlag)).appendTo(container);

                                } catch (e) {
                                    $log.error(e);
                                }
                            }
                        },
                        {
                            dataField: "delFlag",
                            caption: $translate.instant('IsDisplay'),
                            allowHeaderFiltering: true,
                            cellTemplate: function (container, options) {
                                try {
                                    var style = options.data.essenceFlag == 1 ? '' : 'style="color:#999"';

                                    $('<span ' + style + '>').text($scope.delType(options.data.delFlag)).appendTo(container);

                                } catch (e) {
                                    $log.error(e);
                                }
                            }
                        },
                        {
                            dataField: "operation",
                            caption: $translate.instant('Operation'),
                            allowHeaderFiltering: false,
                            cellTemplate: function (container, options) {
                                try {
                                    var eventTarget = $('<a style="color:#506bf7;" data-id="' + options.data.id + '" href="javascript:void(0)"><span>' + $translate.instant("Edit") + '</span></a><span style="width: 10px;display: inline-block"></span>');
                                    eventTarget.off('click').on('click', function () {
                                        $scope.openEditPop(options.data.id);
                                    });
                                    eventTarget.appendTo(container);
                                    var eventTargetDel = $('<a style="color:#506bf7;" data-id="' + options.data.id + '" href="javascript:void(0)"><span>' + $translate.instant("cellCommentDelete") + '</span></a><span style="width: 10px;display: inline-block"></span>');
                                    eventTargetDel.off('click').on('click', function () {
                                        $scope.deleteShare(options.data.id);
                                    });
                                    eventTargetDel.appendTo(container);
                                } catch (e) {
                                    $log.error(e);
                                }
                            }
                        },
                    ],
                    rowAlternationEnabled: false  //单双行颜色
                };
            };
            $scope.getTableHeight = function () {
                var row_height = $("table").find("tr").height();
                if (row_height) {
                    return {
                        height: (row_height * 12 + 100) + "px"
                    }
                }
            };

            $scope.flagType = function (type) {
                if (type == 1) {
                    return "是";
                } else {
                    return "否";
                }
            };

            $scope.delType = function (type) {
                if (type == 1) {
                    return "不显示";
                } else {
                    return "显示";
                }
            };

            $scope.emailType = function (type) {
                if (type == 0) {
                    return "手动添加";
                } else {
                    return "从邮箱获取";
                }
            };
            //取消
            var cancelDocFileType = function () {
                console.log("cancelDocFileType")
            };

            $scope.editModel = {
                "id": null,//主键id
                "essenceFlag": null,
                "topFlag": null,
                "delFlag": null,

            };
            //----------------------kevin insert -------------------------------
            $scope.operation = {};
            $scope.editor1 = "editor1";
            $scope.addShare = function () {
                endProcess();
                $scope.operation.flag = constant.shareTypeFlag.addShare;
                $scope.operation.type = 0;//新建税享
                if ($scope.$editor == undefined) {
                    $scope.$editor = $scope.editorInit('editor1', 0);
                }
                $('#addShareModal').modal();
            };
            $scope.openEditPop = function (rowId) {
                endProcess();
                if ($scope.$editor == undefined) {
                    $scope.$editor = $scope.editorInit('editor1', 0);
                }
                $scope.operation.flag = constant.shareTypeFlag.editShare;
                $scope.operation.type = 1;//编辑税享
                interactionService.getShareDataById(rowId).success(function (res) {
                    if (res.data) {
                        $scope.share = res.data;
                        checkboxConvert.come(res.data);
                        $scope.richText.write($scope.share.content);
                    } else {
                        SweetAlert.error(res.resultMsg);
                    }
                    $('#addShareModal').modal();
                });
            };

            $scope.submit = function (type) {
                if (!$scope.share.title) {
                    SweetAlert.warning("验证", "标题不能为空");
                    $('#title').focus();

                    return false;
                }
                if ($scope.richText.read().length <= 11) {
                    SweetAlert.info("至少输入5个字");
                    return false;
                }
                if (!$scope.share.tag) {
                    SweetAlert.warning("验证", "标签不能为空");
                    $('#tag').focus();
                    return false;
                }
                SweetAlert.swal({
                        title: '提示',
                        text: '请确认是否包含不允许上传的政策法规或公司涉密信息',
                        type: "warning",
                        showCancelButton: true,
                        confirmButtonColor: "#DD6B55",
                        confirmButtonText: $translate.instant('Confirm'),
                        cancelButtonText: $translate.instant('Cancel'),
                        closeOnConfirm: false,
                        closeOnCancel: true
                    },
                    function (isConfirm) {
                        if (isConfirm) {
                            $('#addShareModal').modal('hide');
                            if (type == 0) {//新增
                                var share = {
                                    title: $scope.share.title,
                                    tag: $scope.share.tag,
                                    topFlag: $scope.share.topFlag == true ? 1 : 0,
                                    content: $scope.richText.read(),
                                    delFlag: $scope.share.delFlag == true ? 1 : 0,
                                    essenceFlag: $scope.share.essenceFlag == true ? 1 : 0,
                                    type: 1,
                                };
                                interactionService.addShareHandle(share).success(function (res) {
                                    if (res.result == true) {
                                        SweetAlert.success(res.data);
                                        swal.close();
                                        $scope.loadMainData();
                                    } else {
                                        SweetAlert.error(res.resultMsg);
                                    }
                                })
                            } else {//编辑
                                $scope.share.content = $scope.richText.read();
                                var copyShare = angular.copy($scope.share);
                                checkboxConvert.to(copyShare);
                                delete copyShare.createTime;
                                delete copyShare.updateTime;
                                interactionService.editShareHandle(copyShare).success(function (res) {
                                    if (res.result == true) {
                                        SweetAlert.success(res.data);
                                        swal.close();
                                        $scope.loadMainData();
                                    } else {
                                        SweetAlert.error(res.resultMsg);
                                    }
                                });
                            }
                        } else {
                            swal.close();
                        }
                    });

            };
            //选择框的问题
            var checkboxConvert = {
                come: function (data) {
                    if (data.delFlag == 1) {
                        $scope.share.delFlag = true;
                    } else {
                        $scope.share.delFlag = false;
                    }
                    if (data.essenceFlag == 1) {
                        $scope.share.essenceFlag = true;
                    } else {
                        $scope.share.essenceFlag = false;
                    }
                    if (data.topFlag == 1) {
                        $scope.share.topFlag = true;
                    } else {
                        $scope.share.topFlag = false;
                    }
                },
                to: function (copyShare) {
                    if ($scope.share.delFlag == true) {
                        copyShare.delFlag = 1;
                    } else {
                        copyShare.delFlag = 0;
                    }
                    if ($scope.share.essenceFlag == true) {
                        copyShare.essenceFlag = 1;
                    } else {
                        copyShare.essenceFlag = 0;
                    }
                    if ($scope.share.topFlag == true) {
                        copyShare.topFlag = 1;
                    } else {
                        copyShare.topFlag = 0;
                    }
                }
            };

            $scope.deleteShare = function (id) {
                SweetAlert.swal({
                        title: '确定删除吗？',
                        text: '',
                        type: "warning",
                        showCancelButton: true,
                        confirmButtonColor: "#DD6B55",
                        confirmButtonText: $translate.instant('Confirm'),
                        cancelButtonText: $translate.instant('Cancel'),
                        closeOnConfirm: false,
                        closeOnCancel: true
                    },
                    function (isConfirm) {
                        if (isConfirm) {
                            interactionService.deleteShareDataById(id).success(function (res) {
                                if (res.result == true) {
                                    $scope.loadMainData();
                                    SweetAlert.success($translate.instant('DeleteSuccess'));
                                } else {
                                    SweetAlert.error(res.resultMsg);
                                }
                            });
                        } else {
                            swal.close();
                        }
                    });
            };

            //标签
            function pwcTag(id, tagname, visible) {
                this.tagname = tagname;
                this.id = id,
                    this.visible = visible != undefined ? visible : false;
            }

            //整合数据
            var endProcess = function () {
                $scope.share = {};
                //加标签数据
                interactionService.getTagList(1).then(function (data, status, headers) {
                    if (data.data != null) {
                        var data = data.data;
                        $scope.shareTag = [];
                        data.forEach(function (value, i) {
                            $scope.shareTag.push(new pwcTag(value.id, value.tagname));
                        });
                    } else {
                        SweetAlert.error("加载标签列表失败");
                    }
                });
                $scope.tagSet = false;
                $scope.tagOperation = "添加标签";
                if ($scope.richText != undefined) {
                    $scope.richText.write('');
                }
            };
            var initModalStyle = function () {
                $('#modalStyle').width(window.screen.width - 300);
            };
            $scope.changeSheet = function (item) {
                $scope.share.tag = item;
            };
            $scope.share = {};
            $scope.createTag = function () {
                if ($scope.tagSet == false || $scope.tagSet == undefined) {
                    $scope.tagSet = true;
                    $("#tagInput").show();
                    $scope.tagOperation = "确定";
                } else {
                    if ($scope.share.addTag == "" || $scope.share.addTag == null || $scope.share.addTag == undefined) {
                        SweetAlert.info("输入标签不能为空");
                        return false;
                    }
                    interactionService.addTagSubmit($scope.share.addTag, 1).then(function (data, status, headers) {
                        if (data.resultMsg = "success") {
                            $scope.shareTag.push(new pwcTag(new Date().getTime(), $scope.share.addTag));
                            $scope.share.addTag = '';
                        } else {
                            SweetAlert.error("标签添加失败");
                        }
                        $scope.tagSet = false;
                        $scope.tagOperation = "添加标签";
                        $("#tagInput").hide();
                    })
                }
            };


            var checkUserPermission = function () {

                var list = [];
                $scope.hasTagPermission = false;
                var temp = constant.InteractionPermission;
                list.push(temp.tagOperate.code);
                $scope.$root.checkUserPermissionList(list).success(function (data) {
                    $scope.hasTagPermission = data[temp.tagOperate.code];
                });
            };


            //----------------------insert end -------------------------------
            (function initialize() {
                $scope.loadMainData();
                initModalStyle();
                checkUserPermission();
                //注册方法
                $scope.cancelDocFileType = cancelDocFileType;
            })();
        }]);
