﻿commonModule.controller('editOrganizationModalController', ['$scope', '$log', '$translate', 'uiGridConstants', '$location', '$timeout', '$interval', 'areaRegionService', '$filter', 'SweetAlert', 'regionService', 'orgService', 'organizationStructureService', 'businessUnitService', 'projectService', 'dimensionService',
    function ($scope, $log, $translate, uiGridConstants, $location, $timeout, $interval, areaRegionService, $filter, SweetAlert, regionService, orgService, organizationStructureService, businessUnitService, projectService, dimensionService) {

        var selectedModel = '.addOrgControlPop'; //'#addOrgControlPop' + $scope.dimensionId;

        $scope.pleaseSelect = $translate.instant('PleaseSelect');
        $scope.startDate = new Date(new Date().getFullYear() - 20, 1, 1);
        $scope.endDate = new Date(new Date().getFullYear() + 20, 1, 1);
        $scope.viewMode = 'days';

        var defaultSelcectRegion = {
            id: 0,
            name: '',
            shortName: '',
            mergerName: '',
        };

        $scope.showPage = function (pageIndex) {

            // if (pageIndex === 0)
            // {
            //     $('#orgModalFooter').css('padding-left','139px');
            // } else{
            //     $('#orgModalFooter').css('padding-left','35px');
            // }

        };

        // 新建机构
        var newOrg = function () {
            $scope.editOrgModel = {
                TypeLevel: 1,
                code: ''

            };

            refreshOrg();

            $scope.isAdd = true;
            $scope.isShowBasic = false;
            $scope.isShowAdvanced = false;
            $scope.isShowRight = false;
            $scope.selfDimensionError = false;

            // 选项清空
            $scope.selectLevelType = null;
            $scope.selectProvince = null;
            $scope.selectRegionID = null;

            $scope.componentSelectedArea = null;
            $scope.selectRegion = defaultSelcectRegion;
            $scope.selectProjectIndustry = null;
            $scope.selectBusinessUnit = null;
            if ($scope.newOrganization) {

                // 默认事业部
                if ($scope.newOrganization.businessUnitID) {
                    $scope.selectBusinessUnit = _.find($scope.businessUnitList, function (num) {
                        return num.ID === $scope.newOrganization.businessUnitID;
                    });
                }

                // 默认区域
                if ($scope.newOrganization.areaID && $scope.newOrganization.areaName) {
                    $scope.editOrgModel.areaID = $scope.newOrganization.areaID;
                    $scope.editOrgModel.areaName = $scope.newOrganization.areaName;
                }
            }


            // $scope.orgAccountList = [];
            $scope.serviceList = [];
            $scope.isCheckedServiceList = [];
            // $scope.OrgAccountRowIndex = 1;
            // $scope.newOrgAccountRow();

            // $scope.selfDimensionModel = getAddOrgSetDimension();
            // initIsCheckedServiceList();
            // resetErrorStatus();
            $scope.orgControlForm.$setPristine();
            // $scope.advancedControlForm.$setPristine();
            // set first active page is basic info
            $('#orgControlTab a:first').tab('show');
            // $('#orgModalFooter').css('padding-left','139px');
            $(selectedModel).modal('show');
        };

        $scope.nameKeyUp = function () {
            var hasSpecialChar = window.PWC.hasSpecialChar($scope.editOrgModel.name);

            if (hasSpecialChar) {
                $scope.editOrgModel.nameError = $translate.instant('SpecialChar');
            } else {
                $scope.editOrgModel.nameError = null;
            }
        };

        // 保存机构
        $scope.saveOrg = function () {
            if ($scope.isInternational) {
                saveInternationalOrg();
            } else {
                saveLocalOrg();
            }
        };

        var saveInternationalOrg = function () {
            $scope.orgControlForm.$setSubmitted();
            if (saveVerify()) return;
            var editModel = $scope.editOrgModel;

            // 是否为境外企业
            editModel.oversea = $scope.isInternational;

            if ((typeof $scope.editOrgModel.logoutTime) === "string") {
                if ("" !== ($scope.editOrgModel.logoutTime)) {
                    $scope.editOrgModel.logoutTime = new Date($scope.editOrgModel.logoutTime);
                }
            }

            if ((typeof $scope.editOrgModel.foundationDate) === "string") {
                if ("" !== ($scope.editOrgModel.foundationDate)) {
                    $scope.editOrgModel.foundationDate = new Date($scope.editOrgModel.foundationDate);
                }
            }

            //事业部
            if ($scope.selectBusinessUnit) {
                editModel.businessUnitID = $scope.selectBusinessUnit.ID;
            }
            //区域
            if ($scope.componentSelectedArea) {
                editModel.areaID = $scope.selectedAreaId;
            }

            //所属业务线校验
            if (!editModel.businessUnitID) {
                SweetAlert.error("请检查必填项");
                return;
            }
            //区域校验
            if (editModel.areaID === "") {
                SweetAlert.error("请检查必填项");
                return;
            }

            if ($scope.isAdd) {
                editModel.isActive = true;
                orgService.addOrg(editModel).success(function (orgId) {
                    if (orgId && !orgId.result) {
                        SweetAlert.warning($translate.instant(orgId.resultMsg));
                        return;
                    }

                    $(selectedModel).modal('hide');

                    SweetAlert.success($translate.instant('SaveSuccess'));

                    refreshOrg();
                    $scope.operateType = null;
                    $scope.isUpdate = true;
                });
            } else {
                if (editModel.parentID && $scope.selectedOrganization.suborgList) {

                    if (editModel.parentID === editModel.id) {
                        SweetAlert.warning('上级机构不能为机构本身');
                        return;
                    }

                    var subOrg = _.find($scope.selectedOrganization.suborgList, function (row) {
                        return row.id === editModel.parentID;
                    });

                    if (subOrg) {
                        SweetAlert.warning('不能将当前机构的下级机构设置为其上级公司');
                        return;
                    }
                }
                // editModel.isActive = !editModel.isActive;
                orgService.updateOrg(editModel).success(function (data) {
                    if (data && !data.result) {
                        //SweetAlert.info("Disable", orgId);
                        SweetAlert.warning($translate.instant(data.resultMsg));
                        return;
                    }

                    $(selectedModel).modal('hide');

                    SweetAlert.success($translate.instant('SaveSuccess'));

                    refreshOrg();
                    $scope.operateType = null;
                    $scope.isUpdate = true;
                });
            }
        };

        var saveVerify = function () {

            var fail = false;

            if ($('.localRequired').attr("required") === "required") {
                $('.localRequired').each(function (index, ele) {
                    if (null == ele.value || "" === ele.value) {
                        SweetAlert.error("请检查必填项");
                        fail = true;
                        return false;
                    }
                });
            }
            $('.orgAreaRequired').each(function (index, ele) {
                if (null == ele.innerText || "" === ele.innerText) {
                    SweetAlert.error("请检查必填项");
                    fail = true;
                    return false;
                }
            });
            var taxPlayer = $scope.editOrgModel.taxPayerNumber;
            if (!(taxPlayer.length === 18)) {
                SweetAlert.error($translate.instant('UnifiedSocialCreditCode') + "长度必须为18位");
                fail = true;
                return fail;
            }
            return fail;
        };

        var saveLocalOrg = function () {
            $scope.orgControlForm.$setSubmitted();

            console.log(saveVerify());

            if (saveVerify()) return;

            var hasSpecialChar = window.PWC.hasSpecialChar($scope.editOrgModel.name);
            if (hasSpecialChar) {
                $scope.editOrgModel.nameError = $translate.instant('SpecialChar');
                $scope.isShowBasic = true;
                return false;
            }

            if ($scope.orgControlForm.$invalid) {
                $scope.isShowBasic = true;
                return;
            } else {
                $scope.isShowBasic = false;
            }

            if (checkEnterpriseSetOrg() || checkTemplateList()) {
                $scope.isShowAdvanced = true;
                return;
            } else {
                $scope.isShowAdvanced = false;
            }

            var editModel = $scope.editOrgModel;

            // 是否为境外企业
            editModel.oversea = $scope.isInternational;

            if ($scope.selectProjectIndustry) {
                editModel.industryID = $scope.selectProjectIndustry.id;
            }

            var pId = editModel.parentID;
            //上级公司
            if (!pId || pId === constant.organization.parentIdNull) {
                editModel.parentID = constant.organization.parentIdNull;
            }

            if ((typeof $scope.editOrgModel.foundationDate) === "string") {
                if ("" !== ($scope.editOrgModel.foundationDate)) {
                    $scope.editOrgModel.foundationDate = new Date($scope.editOrgModel.foundationDate);
                }
            }

            if ($scope.isAdd) {
                editModel.isActive = true;
                orgService.addOrg(editModel).success(function (orgId) {
                    if (orgId && !orgId.result) {
                        SweetAlert.warning($translate.instant(orgId.resultMsg));
                        return;
                    }
                    $(selectedModel).modal('hide');

                    SweetAlert.success($translate.instant('SaveSuccess'));

                    refreshOrg();
                    $scope.operateType = null;
                    $scope.isUpdate = true;
                });
            } else {
                if (editModel.parentID && $scope.selectedOrganization.suborgList) {

                    if (editModel.parentID === editModel.id) {
                        SweetAlert.warning('上级机构不能为机构本身');
                        return;
                    }
                    var subOrg = _.find($scope.selectedOrganization.suborgList, function (row) {
                        return row.id === editModel.parentID;
                    });

                    if (subOrg) {
                        SweetAlert.warning('不能将当前机构的下级机构设置为其上级公司');
                        return;
                    }
                }
                // editModel.isActive = !editModel.isActive;
                orgService.updateOrg(editModel).success(function (data) {
                    if (data && !data.result) {
                        //SweetAlert.info("Disable", orgId);
                        SweetAlert.warning($translate.instant(data.resultMsg));
                        return;
                    }
                    $(selectedModel).modal('hide');

                    SweetAlert.success($translate.instant('SaveSuccess'));

                    refreshOrg();
                    $scope.operateType = null;
                    $scope.isUpdate = true;
                });
            }
        };

        // 加载机构
        var loadOrg = function (orgId) {
            resetRegion();

            //清空组织机构，重新获取，达到刷新效果
            $scope.editOrgModel = {
                TypeLevel: 1
            };

            refreshOrg();
            $scope.isShowBasic = false;
            $scope.orgControlForm.$setPristine();

            if (!orgId) {
                orgId = $scope.selectCompany.id;
            }
            $("#selectedOrgName-error").hide();
            $scope.isAdd = false;
            $scope.orgHasAccountMapping = false;
            orgService.getSingleOrg(orgId).success(function (orgData) {
                $scope.selectCompany = orgData;
                $scope.editOrgModel = orgData;
                $scope.editOrgModel.foundationDate = ($filter('date')(new Date($scope.editOrgModel.foundationDate), "yyyy-MM-dd"));
                $scope.orgAccountList = [];
                $scope.serviceList = [];
                $scope.OrgAccountRowIndex = 1;
            });

            if ($scope.isInternational) {
                $('.localRequired').removeAttr("required");
                $('.orgAreaRequired').removeAttr("required");
            }

            // set first active page is basic info
            $('#orgControlTab a:first').tab('show');
            // $('#orgModalFooter').css('padding-left','139px');
            $(selectedModel).modal('show');
        };

        $scope.removeDisabled = function () {
            var businessUnitList = $scope.businessUnitList;
            $scope.businessUnitList = _.without(businessUnitList, _.findWhere(businessUnitList, {
                id: 'newadd'
            }));
        };

        // 重置机构信息
        var resetRegion = function () {

            var defaultData = null;
            $scope.CityList = defaultData;
            $scope.ProvinceList = defaultData;
            $scope.selectProvince = defaultData;
            $scope.selectCity = defaultData;
            $scope.selectRegionID = defaultData;
        };

        // 基础数据初始化
        var init = function () {
            initDatePicker();
        };

        // 验证开始时间
        $scope.checkStartDate = function (row) {

            if (row.startDate && !window.PWC.checkMonth(row.startDate)) {
                row.startDateError = $scope.resources.DateMonthFormatError;
                return;
            } else {
                row.startDateError = null;
            }

            if (!row.enterpriseAccountSetSelectID && !row.startDate && !row.endDate) {
                row.startDateError = null;
                return;
            }

            // if (!row.startDate) {
            //     row.startDateError = $scope.resources.EffectiveDateRequired;
            // } else {
            //     row.startDateError = null;
            // }

            if (row.startDate && row.endDate) {

                if (!validateDate(row.startDate, row.endDate)) {
                    row.startDateError = $scope.resources.EffectiveDateAreaProblem;
                } else {
                    row.startDateError = null;
                }
            }
        };

        // 验证结束时间
        $scope.checkEndDate = function (row) {


            // if (!row.endDate) {
            //     row.endDateError = $scope.resources.ExpiredDateRequired;
            // } else {
            //     row.endDateError = null;
            // }

            if (row.endDate && !window.PWC.checkMonth(row.endDate)) {
                row.endDateError = $scope.resources.DateMonthFormatError;
                return;
            } else {
                row.endDateError = null;
            }

            if (!row.enterpriseAccountSetSelectID && !row.startDate && !row.endDate) {
                row.endDateError = null;
                return;
            }


            if (row.startDate && row.endDate) {

                if (!validateDate(row.startDate, row.endDate)) {
                    row.startDateError = $scope.resources.EffectiveDateAreaProblem;
                } else {
                    row.startDateError = null;
                }
            }
        };

        // 说明
        $scope.resources = {
            OrganizationName: $translate.instant('OrganizationName'),
            OrganizationNameEn: $translate.instant('OrganizationNameEn'),
            RegistrationCapital: $translate.instant('RegistrationCapital'),
            LegalPersonName: $translate.instant('LegalPersonName'),
            NumOfBranches: $translate.instant('NumOfBranches'),
            BusinessScope: $translate.instant('BusinessScope'),
            UnifiedSocialCreditCode: $translate.instant('UnifiedSocialCreditCode'),
            Abbreviation: $translate.instant('Abbreviation'),
            RegistrationLocationEn: $translate.instant('RegistrationLocationEn'),

            PaidInCapital: $translate.instant('PaidInCapital'),
            FoundationDate: $translate.instant('FoundationDate'),

            registrationLocation: $translate.instant('RegistrationLocation'),
            OrganizationMsgNameRequired: $translate.instant('OrganizationMsgNameRequired'),
            OrganizationParent: $translate.instant('OrganizationParent'),
            OrganizationLevelType: $translate.instant('OrganizationLevelType'),
            OrganizationMsgLevelTypeRequired: $translate.instant('OrganizationMsgLevelTypeRequired'),
            OrganizationClientCode: $translate.instant('OrganizationClientCode'),
            OrganizationMsgClientCodeRequired: $translate.instant('OrganizationMsgClientCodeRequired'),
            OrganizationCode: $translate.instant('OrganizationCode'),
            OrganizationMsgCodeRequired: $translate.instant('OrganizationMsgCodeRequired'),
            OrganizationMsgCodeMaxLength: $translate.instant('OrganizationMsgCodeMaxLength'),
            OrganizationMsgCodePattern: $translate.instant('OrganizationMsgCodePattern'),
            OrganizationMsgCodeUnique: $translate.instant('OrganizationMsgCodeUnique'),
            OrganizationTaxPayerNumber: $translate.instant('OrganizationTaxPayerNumber'),
            OrganizationMsgTaxPayerNumberUnique: $translate.instant('OrganizationMsgTaxPayerNumberUnique'),
            OrganizationMsgAreaRequired: $translate.instant('OrganizationMsgAreaRequired'),
            OrganizationMsgProvinceRequired: $translate.instant('OrganizationMsgProvinceRequired'),
            OrganizationMsgRegStatusRequired: $translate.instant('OrganizationMsgRegStatusRequired'),
            OrganizationMsgEngageNationalProhibitIndustryRequired: $translate.instant('OrganizationMsgEngageNationalProhibitIndustryRequired'),
            OrganizationMsgArchitectureTypeRequired: $translate.instant('OrganizationMsgArchitectureTypeRequired'),
            OrganizationMsgCityRequired: $translate.instant('OrganizationMsgCityRequired'),
            OrganizationMsgEnterpriseAccountSetRequired: $translate.instant('OrganizationMsgEnterpriseAccountSetRequired'),
            EffectiveDateRequired: $translate.instant('EffectiveDateRequired'),
            ExpiredDateRequired: $translate.instant('ExpiredDateRequired'),
            EffectiveDateAreaProblem: $translate.instant('EffectiveDateAreaProblem'),
            OrganizationMsgTemplateRequired: $translate.instant('OrganizationMsgTemplateRequired'),
            OrganizationMsgProjectIndustryRequired: $translate.instant('OrganizationMsgProjectIndustryRequired'),
            DateMonthFormatError: $translate.instant('DateMonthFormatError')
        };

        // 行业发生改变时，只有在已经做过科目对应的机构，且行业是非房地产和房地产 切换时，才需要给出需要重新做科目对应的提示
        $scope.ProjectIndustryChanged = function () {

            //添加机构，过滤,  如果没有做过科目对应，过滤
            if ($scope.isAdd || !$scope.orgHasAccountMapping) {
                return;
            }

            var com = $scope.selectCompany;
            var industry = $scope.selectProjectIndustry;
            if (!industry || !com)
                return;

            var orgID = $scope.selectCompany.id;
            //房地产行业ID
            var Estateid = constant.organization.EstateIndustryId;
            ////仅仅在房地产行业和非房地产行业之间切换时给予提示
            if (com.industryID != industry.id) {
                if (com.industryID == Estateid && industry.id != Estateid) {
                    SweetAlert.warning($translate.instant("OrganizationIndustryChanged"));
                }
                else if (com.industryID != Estateid && industry.id == Estateid) {
                    SweetAlert.warning($translate.instant("OrganizationIndustryChanged"));
                }
                ////仅仅在房地产行业和非房地产行业之间切换时给予提示
                //if (com.industryID != Estateid && industry.id != Estateid)
                //    return;

                //SweetAlert.warning($translate.instant("OrganizationIndustryChanged"));
            }
        };


        $scope.$watch('operateType', function (newValue, oldValue) {
            if (newValue) {

                if (newValue == constant.Operation.Add) {
                    // add
                    newOrg();
                } else if (newValue == constant.Operation.Edit) {
                    if ($scope.selectedOrganization) {
                        loadOrg($scope.selectedOrganization.id);
                    }
                }
            }
        });

        $scope.$watch('forceUpdate', function (newValue, oldValue) {
            if (newValue) {
                $scope.forceUpdate = false;
                initParams();
                init();
            }
        });


        $scope.changeInternational = function () {
            $scope.isLocal = false;
            $scope.isInternational = true;
            $('.localRequired').removeAttr("required");
            $('.orgAreaRequired').removeAttr("required");
        };

        $scope.changeLocal = function () {
            $scope.isLocal = true;
            $scope.isInternational = false;
            $('.localRequired').attr("required", true);
            $('.orgAreaRequired').attr("required", true);
        };

        // 强制刷新机构控件里的机构
        var refreshOrg = function () {
            $scope.editOrgModel.componentSelectedOrg = {};
            $scope.editOrgModel.componentSelectedOrg.forceRefresh = true;
        };

        $(".addOrgControlPop").on("hidden.bs.modal", function () {
            $('.modal-backdrop').remove();
            $(".addOrgControlPop").hide();
            $scope.operateType = null;

        });

        $scope.closeModal = function () {
            $scope.operateType = null;
        };

        // 初始化参数信息
        var initParams = function () {
            $scope.editOrgModel = {};
            $scope.selectCompany = {};
            $scope.isLocal = true;
            // 登记状态
            $scope.regStatusList = constant.RegStatusList;
            $scope.architectureTypeList = constant.ArchitectureTypeList;
            $scope.nationalEconomicIndustryList = constant.NationalEconomicIndustryList;
            $scope.trueFalse = constant.trueFalse;
            $scope.countryCNList = constant.countryCNList;
            $('.localRequired').attr("required", true);
            $('.orgAreaRequired').attr("required", true);


            $scope.equityGridOptions = {
                bindingOptions: {
                    dataSource: 'shareholderDatasource'
                },
                showBorders: true,
                paging: {
                    pageSize: constant.page.logPageSize
                },
                pager: {
                    showPageSizeSelector: true,
                    allowedPageSizes: constant.page.pageSizeArrary,
                    showInfo: true
                },
                keyExpr: "id",
                columns: [
                    {
                        dataField: "investment_entity_id",
                        allowHeaderFiltering: false,
                        caption: $translate.instant('InvestmentEntity'),
                        calculateDisplayValue: function (data) {
                            // var importType1 = _.find(constant.importTypeList, function (item) {
                            //     return item.value == data.importType;
                            // });
                            // if (importType1) {
                            //     return importType1.name;
                            // } else {
                            //     return '未知';
                            // }
                        }
                    },
                    {
                        dataField: "ownershipForm",
                        allowHeaderFiltering: false,
                        caption: $translate.instant('ownershipForm'),
                    },
                    {
                        dataField: "commonPreferred",
                        allowHeaderFiltering: false,
                        caption: $translate.instant('CommonPreferred'),
                        calculateDisplayValue: function (data) {
                            // var importType1 = _.find(constant.importTypeList, function (item) {
                            //     return item.value == data.importType;
                            // });
                            // if (importType1) {
                            //     return importType1.name;
                            // } else {
                            //     return '未知';
                            // }
                        }
                    },
                    {
                        dataField: "classOfShares",
                        allowHeaderFiltering: false,
                        caption: $translate.instant('classOfShares'),
                    },
                    {
                        dataField: "votingPercentage",
                        allowHeaderFiltering: false,
                        caption: $translate.instant('votingPercentage'),
                    },
                    {
                        dataField: "id",
                        allowHeaderFiltering: false,
                        caption: $translate.instant('operation'),
                        cellTemplate: function (container, options) {
                            try {
                                $('<button type="button"  class="btn btn-in-grid" style="margin-top: -11px;" onclick = "editShareholder(' + options.data.id + ')"><i class="material-icons middle" style="vertical-align: text-bottom">modify</i>edit</button>&nbsp;&nbsp;')
                                    .appendTo(container);
                                $('<button type="button"  class="btn btn-in-grid" style="margin-top: -11px;" onclick = "deleteShareholder(' + options.data.id + ')"><i class="material-icons middle" style="vertical-align: text-bottom">delete</i>delete</button>&nbsp;&nbsp;')
                                    .appendTo(container);
                            }
                            catch (e) {
                                $log.error(e);
                            }
                        }
                    }
                ],
                onContentReady: function (e) {
                    $scope.shareholderGridInstance = e.component;
                },
                loadPanel: {
                    enabled: false
                },
                selection: {
                    mode: "single"
                },
                grouping: {
                    autoExpandAll: false
                },
                allowColumnResizing: true,
                columnAutoWidth: true,
                showRowLines: true,
                allowColumnReordering: true,
                showColumnLines: true,
                rowAlternationEnabled: true,  //单双行颜色
                noDataText: $translate.instant('NoDataText'),
                selectAllText: $translate.instant('SelectAll'),
                searchPanel: {
                    placeholder: $translate.instant('Search'),
                    width: 518,
                    visible: false
                },
                headerFilter: {
                    visible: false,
                    texts: {
                        cancel: $translate.instant('Cancel'),
                        ok: $translate.instant('Confirm'),
                        emptyValue: $translate.instant('Empty'),
                        selectAllText: $translate.instant('SelectAll')
                    }
                }
            };

            $scope.directorGridOptions = {
                bindingOptions: {
                    dataSource: 'directorDatasource'
                },
                showBorders: true,
                paging: {
                    pageSize: constant.page.logPageSize
                },
                pager: {
                    showPageSizeSelector: true,
                    allowedPageSizes: constant.page.pageSizeArrary,
                    showInfo: true
                },
                keyExpr: "id",
                columns: [
                    {
                        dataField: "director_name",
                        allowHeaderFiltering: false,
                        caption: $translate.instant('director_name')
                    },
                    {
                        dataField: "residency",
                        allowHeaderFiltering: false,
                        caption: $translate.instant('residency'),
                    },
                    {
                        dataField: "date_of_appointment",
                        allowHeaderFiltering: false,
                        caption: $translate.instant('date_of_appointment'),
                        calculateDisplayValue: function (data) {
                            // var importType1 = _.find(constant.importTypeList, function (item) {
                            //     return item.value == data.importType;
                            // });
                            // if (importType1) {
                            //     return importType1.name;
                            // } else {
                            //     return '未知';
                            // }
                        }
                    },
                    {
                        dataField: "date_of_resignation",
                        allowHeaderFiltering: false,
                        caption: $translate.instant('date_of_resignation'),
                    },
                    {
                        dataField: "is_executive",
                        allowHeaderFiltering: false,
                        caption: $translate.instant('is_executive'),
                    },
                    {
                        dataField: "other_roles",
                        allowHeaderFiltering: false,
                        caption: $translate.instant('other_roles'),
                    },
                    {
                        dataField: "id",
                        allowHeaderFiltering: false,
                        caption: $translate.instant('operation'),
                        cellTemplate: function (container, options) {
                            try {
                                $('<button type="button"  class="btn btn-in-grid" style="margin-top: -11px;" onclick = "editDirector(' + options.data.id + ')"><i class="material-icons middle" style="vertical-align: text-bottom">modify</i>edit</button>&nbsp;&nbsp;')
                                    .appendTo(container);
                                $('<button type="button"  class="btn btn-in-grid" style="margin-top: -11px;" onclick = "deleteDirector(' + options.data.id + ')"><i class="material-icons middle" style="vertical-align: text-bottom">delete</i>delete</button>&nbsp;&nbsp;')
                                    .appendTo(container);
                            }
                            catch (e) {
                                $log.error(e);
                            }
                        }
                    }
                ],
                onContentReady: function (e) {
                    $scope.directorGridInstance = e.component;
                },
                loadPanel: {
                    enabled: false
                },
                selection: {
                    mode: "single"
                },
                grouping: {
                    autoExpandAll: false
                },
                allowColumnResizing: true,
                columnAutoWidth: true,
                showRowLines: true,
                allowColumnReordering: true,
                showColumnLines: true,
                rowAlternationEnabled: true,  //单双行颜色
                noDataText: $translate.instant('NoDataText'),
                selectAllText: $translate.instant('SelectAll'),
                searchPanel: {
                    placeholder: $translate.instant('Search'),
                    width: 518,
                    visible: false
                },
                headerFilter: {
                    visible: false,
                    texts: {
                        cancel: $translate.instant('Cancel'),
                        ok: $translate.instant('Confirm'),
                        emptyValue: $translate.instant('Empty'),
                        selectAllText: $translate.instant('SelectAll')
                    }
                }
            };

            // $('.localRequired').attr("required","true"); required="required"
        };

        var initDatePicker = function () {
            var ele = $(".startDatepicker");
            ele.datepicker({
                startDate: $scope.startDate,
                endDate: $scope.endDate,
                viewMode: $scope.viewMode,
                minViewMode: $scope.viewMode,
                autoclose: true, //选中之后自动隐藏日期选择框
                clearBtn: true, //清除按钮
                todayBtn: false, //今日按钮
                format: 'yyyy/mm/dd' //日期格式，详见 http://bootstrap-datepicker.readthedocs.org/en/release/options.html#format
            });
            ele.datepicker("setDate", new Date().formatDateTime('yyyy/mm/dd'));

        };

        (function initialize() {
            $log.debug('editOrganizationModalController.ctor()...');
            $scope.maxdropLength = 20;
            $scope.maxTitleLength = 10;
            initParams();
            init();
        })();
    }
]);
