﻿commonModule.controller('pdfMainController',
    ['$log', '$http', '$q', '$scope', '$translate', '$timeout', 'SweetAlert', '$compile', 'interactionService', '$filter', 'Upload', 'apiInterceptor',
        function ($log, $http, $q, $scope, $translate, $timeout, SweetAlert, $compile, interactionService, $filter, Upload, apiInterceptor) {
            window.PDFJS.workerSrc = '../../bundles/pdf.worker.js';
            var canvas = document.getElementById('the-canvas');
            var context = canvas.getContext('2d');
            var pdfCurPageIndex = 1;
            var pdfSumPages = 1;
            var container = document.getElementById("pdfLayoutDialog");
            var pdfPromise = null;
            var cacheUrl = null;
            var pageInfo = null;//pdf页面信息
            var angle = 0;//旋转角度
            $scope.openPdfPreviewPop_bak = function (url) {
                container.style.display = "block";
                if (cacheUrl !== url) {
                    cacheUrl = url;
                    pdfPromise = getPdf(url);
                }
                pdfPromise.then(function (pdf) {
                    renderPdf(pdf)
                })
            };
            $scope.openPdfPreviewPop = function (url) {
                container.style.display = "block";

                function start() {
                    return new Promise(function (resolve, reject) {
                        resolve('start');
                    });
                }

                start().then(function (data) {
                    return interactionService.readPDF({path: url});
                }).then(function (data) {
                    var dataURL = data.data;
                    var pdfData = null;
                    if (typeof dataURL == "string") {
                        pdfData = convertDataURIToBinary(dataURL);
                    }
                    pdfPromise = window.PDFJS.getDocument({data: pdfData});
                    return window.PDFJS.getDocument({data: pdfData});
                }).then(function (data) {
                    pdfSumPages = data.numPages;
                    return data.getPage(pdfCurPageIndex);
                }).then(function (page) {
                    pageInfo = page;
                    var scale = 1.5;
                    var viewport = page.getViewport(scale);
                    canvas.height = viewport.height;
                    canvas.width = viewport.width;
                    var renderContext = {
                        canvasContext: context,
                        viewport: viewport
                    };
                    page.render(renderContext);
                });
            };

            function convertDataURIToBinary(dataURI) { //将encodeBase64解码
                var raw = window.atob(dataURI);
                var rawLength = raw.length;
                //转换成pdf.js能直接解析的Uint8Array类型,见pdf.js-4068
                var array = new Uint8Array(new ArrayBuffer(rawLength));
                for (var i = 0; i < rawLength; i++) {
                    array[i] = raw.charCodeAt(i);
                }
                return array;
            }

            $scope.closePdfPop = function () {
                //canvas高度被重设,实现画布清空
                canvas.height = canvas.height;
                //隐藏窗体
                container.style.display = "none";
            };
            $scope.prevPaging = function () {
                if (pdfCurPageIndex <= 1) return pdfCurPageIndex = 1;
                pdfCurPageIndex--;
                pdfPromise.then(function (pdf) {
                    renderPdf(pdf)
                })
            };
            $scope.nextPaging = function () {
                if (pdfCurPageIndex >= pdfSumPages) return pdfCurPageIndex = pdfSumPages;
                pdfCurPageIndex++;
                pdfPromise.then(function (pdf) {
                    renderPdf(pdf)
                })
            };
            $scope.webViewerRotateCw = function () {
                angle += 90;
                var scale = 1.5;
                var viewport = pageInfo.getViewport(1.5, angle);
                canvas.height = viewport.height;
                canvas.width = viewport.width;
                var renderContext = {
                    canvasContext: context,
                    viewport: viewport
                };
                pageInfo.render(renderContext);
            };

            function getPdf(url) {
                // var url = 'http://47.94.233.173:11007/static/erp_tax_system/61063D1D-8C9E-47C1-B106-AFF696CF5D98?expire=1552466477&signiture=5IaoVIHX_pzmQgyaxdzYC2NsNOz_R0eyRUhQU1BJjiE=';
                return window.PDFJS.getDocument(url);
            }

            function renderPdf(pdf) {
                pdfSumPages = pdf.numPages;
                pdf.getPage(pdfCurPageIndex).then(function getPageHelloWorld(page) {

                    var scale = 1.5;
                    var viewport = page.getViewport(scale);

                    //
                    // Prepare canvas using PDF page dimensions
                    //
                    canvas.height = viewport.height;
                    canvas.width = viewport.width;

                    //
                    // Render PDF page into canvas context
                    //
                    var renderContext = {
                        canvasContext: context,
                        viewport: viewport
                    };
                    page.render(renderContext);
                });
            }

            (function init() {
                if($scope.operationStyle != null && $scope.operationStyle != undefined){
                    $scope.operationStyle();
                }

            })();
        }]
);